#include "main.h"
#include "calc.h"
#include "init.h"
#include "draw.h"
#include "hud.h"
#include "io.h"

void menu_functions(int menu_number, char *button_name, int x, int y, int x1, int y1, int mx, int my){
	
	if((mx<x1)&&(mx>x)&&(my>y)&&(my<y1)){
		print_font(button_name,x,600-y1,0.2,1,0.2);
		switch(menu_number){
			case 0:
			{
				if(mb1==1){
					init_objects( );
					menu=0;
					mb1=0;
					SDL_WM_GrabInput(SDL_GRAB_ON);
				}
				break;
			}
			case 1:
			{
				if(mb1==1){
					menu=2;
					mb1=0;
				}
				break;
			}
			case 2:
			{
				if(mb1==1){
					menu=3;
					mb1=0;
				}
				break;
			}

			case 3:
			{
				if(mb1==1){
					Quit(0);
				}
				break;
			}

			case 4:
			{
				if(mb1==1){
					if(audio){audio=0;}
					else{audio=1;}
					mb1=0;
				}
				break;
			}

			case 5:
			{
				if(mb1==1){
					volume++;
					if(volume>=MIX_MAX_VOLUME)volume=0;
				}
				break;
			}

			case 6:
			{
				if(mb1==1){
					save_config();
					mb1=0;
				}
				break;
			}

			case 7:
			{
				if(mb1==1){
					menu=1;
					mb1=0;
				}
				break;
			}
		}
	}
	else{print_font(button_name, x,600-y1,0.23,0.6,0.23);}
}


void show_menu(int menunum, unsigned char key, int mx, int my){

	unsigned char buf[32];

	/*if(changed){*/
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

		glLoadIdentity();
		SDL_ShowCursor(1);
		SDL_WM_GrabInput(SDL_GRAB_OFF);

		goto_ortho();
		glDisable(GL_DEPTH_TEST);
		glEnable(GL_BLEND); 
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	

	switch(menunum){

		case 1:
		{
			glBindTexture(GL_TEXTURE_2D,  texture[2]);
			glBegin(GL_QUADS);
		      		glTexCoord2f(1.0f, 1.0f);    glVertex2f(580, 520);
		     		glTexCoord2f(1.0f, 0.0f);    glVertex2f(580, 580);
  		    		glTexCoord2f(0.0f, 0.0f);    glVertex2f(220, 580);
 	   		   		glTexCoord2f(0.0f, 1.0f);    glVertex2f(220, 520);
 			glEnd(); 
			glBindTexture(GL_TEXTURE_2D,  texture[4]);
			glBegin(GL_QUADS);
		      		glTexCoord2f(1.0f, 1.0f);    glVertex2f(600, 420);
 		     		glTexCoord2f(1.0f, 0.0f);    glVertex2f(600, 480);
  		    		glTexCoord2f(0.0f, 0.0f);    glVertex2f(220, 480);
  	   		   		glTexCoord2f(0.0f, 1.0f);    glVertex2f(220, 420);
    			glEnd();
	
			print_font("Presents...",370,500,0,1,0);
			
			menu_functions(0,"NEW GAME..." ,370,235,430,250,mx,my);
			menu_functions(1,"HALL OF FAME",370,260,450,275,mx,my);
			menu_functions(2,"SETUP"       ,370,285,430,300,mx,my);
			menu_functions(3,"QUIT"        ,370,310,430,325,mx,my);
			print_font("v0.91: Coded by blud0t - http://projectz.ath.cx",235,120,0.2,0.6,0.2);
			break;
		}		

		case 2:
		{
			if((mb1==1)||(!display_highscore_file())){
				menu=1;
				mb1=0;
			}
			break;
		}

		case 3:
		{
			if(key==0x08){
				if(strlen(name)>0)name[strlen(name)-1]=0x00;
		 	}
			else{
				if(strlen(name)<16){
					name[strlen(name)+1]=0x00;
					name[strlen(name)]=key;
				}
			}
			
			sprintf(buf,"Name: %s", name);
			print_font(buf,370,350,0.23,0.6,0.23);
			
			if(audio){sprintf(buf,"Audio: ON");}
			else{sprintf(buf,"Audio: OFF");}
			menu_functions(4,buf      ,370,260,430,275,mx,my);
		   	sprintf(buf,"Volume: %i", volume);
			menu_functions(5,buf      ,370,285,430,300,mx,my);
			menu_functions(6,"SAVE"   ,370,310,430,325,mx,my);
			menu_functions(7,"DONE"   ,370,335,430,350,mx,my);			
			break;
		}
	}


	/*if(changed){*/
		glDisable(GL_BLEND);
		glEnable(GL_DEPTH_TEST);
		exit_ortho();
		calculate_timing();
		SDL_GL_SwapBuffers();
}		